Index: XIOS/trunk/src/interface/fortran_attr/idomaingroup_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/idomaingroup_attr.F90	(revision 449)
+++ XIOS/trunk/src/interface/fortran_attr/idomaingroup_attr.F90	(revision 467)
@@ -13,8 +13,8 @@
   SUBROUTINE xios(set_domaingroup_attr)  &
     ( domaingroup_id, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin  &
-    , jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj  &
-    , zoom_nj_loc )
+    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, i_index, ibegin  &
+    , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
+    , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
+    , zoom_ni_loc, zoom_nj, zoom_nj_loc )
     
     IMPLICIT NONE
@@ -33,6 +33,8 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_group_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: group_ref
+      INTEGER  , OPTIONAL, INTENT(IN) :: i_index(:,:)
       INTEGER  , OPTIONAL, INTENT(IN) :: ibegin
       INTEGER  , OPTIONAL, INTENT(IN) :: iend
+      INTEGER  , OPTIONAL, INTENT(IN) :: j_index(:,:)
       INTEGER  , OPTIONAL, INTENT(IN) :: jbegin
       INTEGER  , OPTIONAL, INTENT(IN) :: jend
@@ -62,8 +64,8 @@
       CALL xios(set_domaingroup_attr_hdl_)   &
       ( domaingroup_hdl, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin  &
-      , jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj  &
-      , zoom_nj_loc )
+      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, i_index, ibegin  &
+      , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
+      , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
+      , zoom_ni_loc, zoom_nj, zoom_nj_loc )
     
   END SUBROUTINE xios(set_domaingroup_attr)
@@ -71,8 +73,8 @@
   SUBROUTINE xios(set_domaingroup_attr_hdl)  &
     ( domaingroup_hdl, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin  &
-    , jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj  &
-    , zoom_nj_loc )
+    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, i_index, ibegin  &
+    , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
+    , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
+    , zoom_ni_loc, zoom_nj, zoom_nj_loc )
     
     IMPLICIT NONE
@@ -90,6 +92,8 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_group_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: group_ref
+      INTEGER  , OPTIONAL, INTENT(IN) :: i_index(:,:)
       INTEGER  , OPTIONAL, INTENT(IN) :: ibegin
       INTEGER  , OPTIONAL, INTENT(IN) :: iend
+      INTEGER  , OPTIONAL, INTENT(IN) :: j_index(:,:)
       INTEGER  , OPTIONAL, INTENT(IN) :: jbegin
       INTEGER  , OPTIONAL, INTENT(IN) :: jend
@@ -118,8 +122,8 @@
       CALL xios(set_domaingroup_attr_hdl_)  &
       ( domaingroup_hdl, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin  &
-      , jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj  &
-      , zoom_nj_loc )
+      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, i_index, ibegin  &
+      , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
+      , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
+      , zoom_ni_loc, zoom_nj, zoom_nj_loc )
     
   END SUBROUTINE xios(set_domaingroup_attr_hdl)
@@ -127,8 +131,8 @@
   SUBROUTINE xios(set_domaingroup_attr_hdl_)   &
     ( domaingroup_hdl, bounds_lat_, bounds_lon_, data_dim_, data_i_index_, data_ibegin_, data_j_index_  &
-    , data_jbegin_, data_n_index_, data_ni_, data_nj_, domain_group_ref_, group_ref_, ibegin_, iend_  &
-    , jbegin_, jend_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_, ni_glo_, nj_, nj_glo_  &
-    , nvertex_, standard_name_, type_, zoom_ibegin_, zoom_ibegin_loc_, zoom_jbegin_, zoom_jbegin_loc_  &
-    , zoom_ni_, zoom_ni_loc_, zoom_nj_, zoom_nj_loc_ )
+    , data_jbegin_, data_n_index_, data_ni_, data_nj_, domain_group_ref_, group_ref_, i_index_, ibegin_  &
+    , iend_, j_index_, jbegin_, jend_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_, ni_glo_  &
+    , nj_, nj_glo_, nvertex_, standard_name_, type_, zoom_ibegin_, zoom_ibegin_loc_, zoom_jbegin_  &
+    , zoom_jbegin_loc_, zoom_ni_, zoom_ni_loc_, zoom_nj_, zoom_nj_loc_ )
     
     IMPLICIT NONE
@@ -146,6 +150,8 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_group_ref_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: group_ref_
+      INTEGER  , OPTIONAL, INTENT(IN) :: i_index_(:,:)
       INTEGER  , OPTIONAL, INTENT(IN) :: ibegin_
       INTEGER  , OPTIONAL, INTENT(IN) :: iend_
+      INTEGER  , OPTIONAL, INTENT(IN) :: j_index_(:,:)
       INTEGER  , OPTIONAL, INTENT(IN) :: jbegin_
       INTEGER  , OPTIONAL, INTENT(IN) :: jend_
@@ -220,4 +226,8 @@
       ENDIF
       
+      IF (PRESENT(i_index_)) THEN
+        CALL cxios_set_domaingroup_i_index(domaingroup_hdl%daddr, i_index_,size(i_index_,1),size(i_index_,2))
+      ENDIF
+      
       IF (PRESENT(ibegin_)) THEN
         CALL cxios_set_domaingroup_ibegin(domaingroup_hdl%daddr, ibegin_)
@@ -226,4 +236,8 @@
       IF (PRESENT(iend_)) THEN
         CALL cxios_set_domaingroup_iend(domaingroup_hdl%daddr, iend_)
+      ENDIF
+      
+      IF (PRESENT(j_index_)) THEN
+        CALL cxios_set_domaingroup_j_index(domaingroup_hdl%daddr, j_index_,size(j_index_,1),size(j_index_,2))
       ENDIF
       
@@ -324,8 +338,8 @@
   SUBROUTINE xios(get_domaingroup_attr)  &
     ( domaingroup_id, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin  &
-    , jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj  &
-    , zoom_nj_loc )
+    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, i_index, ibegin  &
+    , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
+    , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
+    , zoom_ni_loc, zoom_nj, zoom_nj_loc )
     
     IMPLICIT NONE
@@ -344,6 +358,8 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_group_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: group_ref
+      INTEGER  , OPTIONAL, INTENT(OUT) :: i_index(:,:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: ibegin
       INTEGER  , OPTIONAL, INTENT(OUT) :: iend
+      INTEGER  , OPTIONAL, INTENT(OUT) :: j_index(:,:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: jbegin
       INTEGER  , OPTIONAL, INTENT(OUT) :: jend
@@ -373,8 +389,8 @@
       CALL xios(get_domaingroup_attr_hdl_)   &
       ( domaingroup_hdl, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin  &
-      , jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj  &
-      , zoom_nj_loc )
+      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, i_index, ibegin  &
+      , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
+      , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
+      , zoom_ni_loc, zoom_nj, zoom_nj_loc )
     
   END SUBROUTINE xios(get_domaingroup_attr)
@@ -382,8 +398,8 @@
   SUBROUTINE xios(get_domaingroup_attr_hdl)  &
     ( domaingroup_hdl, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin  &
-    , jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj  &
-    , zoom_nj_loc )
+    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, i_index, ibegin  &
+    , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
+    , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
+    , zoom_ni_loc, zoom_nj, zoom_nj_loc )
     
     IMPLICIT NONE
@@ -401,6 +417,8 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_group_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: group_ref
+      INTEGER  , OPTIONAL, INTENT(OUT) :: i_index(:,:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: ibegin
       INTEGER  , OPTIONAL, INTENT(OUT) :: iend
+      INTEGER  , OPTIONAL, INTENT(OUT) :: j_index(:,:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: jbegin
       INTEGER  , OPTIONAL, INTENT(OUT) :: jend
@@ -429,8 +447,8 @@
       CALL xios(get_domaingroup_attr_hdl_)  &
       ( domaingroup_hdl, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin  &
-      , jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj  &
-      , zoom_nj_loc )
+      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, i_index, ibegin  &
+      , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
+      , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
+      , zoom_ni_loc, zoom_nj, zoom_nj_loc )
     
   END SUBROUTINE xios(get_domaingroup_attr_hdl)
@@ -438,8 +456,8 @@
   SUBROUTINE xios(get_domaingroup_attr_hdl_)   &
     ( domaingroup_hdl, bounds_lat_, bounds_lon_, data_dim_, data_i_index_, data_ibegin_, data_j_index_  &
-    , data_jbegin_, data_n_index_, data_ni_, data_nj_, domain_group_ref_, group_ref_, ibegin_, iend_  &
-    , jbegin_, jend_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_, ni_glo_, nj_, nj_glo_  &
-    , nvertex_, standard_name_, type_, zoom_ibegin_, zoom_ibegin_loc_, zoom_jbegin_, zoom_jbegin_loc_  &
-    , zoom_ni_, zoom_ni_loc_, zoom_nj_, zoom_nj_loc_ )
+    , data_jbegin_, data_n_index_, data_ni_, data_nj_, domain_group_ref_, group_ref_, i_index_, ibegin_  &
+    , iend_, j_index_, jbegin_, jend_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_, ni_glo_  &
+    , nj_, nj_glo_, nvertex_, standard_name_, type_, zoom_ibegin_, zoom_ibegin_loc_, zoom_jbegin_  &
+    , zoom_jbegin_loc_, zoom_ni_, zoom_ni_loc_, zoom_nj_, zoom_nj_loc_ )
     
     IMPLICIT NONE
@@ -457,6 +475,8 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_group_ref_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: group_ref_
+      INTEGER  , OPTIONAL, INTENT(OUT) :: i_index_(:,:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: ibegin_
       INTEGER  , OPTIONAL, INTENT(OUT) :: iend_
+      INTEGER  , OPTIONAL, INTENT(OUT) :: j_index_(:,:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: jbegin_
       INTEGER  , OPTIONAL, INTENT(OUT) :: jend_
@@ -531,4 +551,8 @@
       ENDIF
       
+      IF (PRESENT(i_index_)) THEN
+        CALL cxios_get_domaingroup_i_index(domaingroup_hdl%daddr, i_index_,size(i_index_,1),size(i_index_,2))
+      ENDIF
+      
       IF (PRESENT(ibegin_)) THEN
         CALL cxios_get_domaingroup_ibegin(domaingroup_hdl%daddr, ibegin_)
@@ -537,4 +561,8 @@
       IF (PRESENT(iend_)) THEN
         CALL cxios_get_domaingroup_iend(domaingroup_hdl%daddr, iend_)
+      ENDIF
+      
+      IF (PRESENT(j_index_)) THEN
+        CALL cxios_get_domaingroup_j_index(domaingroup_hdl%daddr, j_index_,size(j_index_,1),size(j_index_,2))
       ENDIF
       
@@ -635,8 +663,8 @@
   SUBROUTINE xios(is_defined_domaingroup_attr)  &
     ( domaingroup_id, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin  &
-    , jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj  &
-    , zoom_nj_loc )
+    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, i_index, ibegin  &
+    , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
+    , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
+    , zoom_ni_loc, zoom_nj, zoom_nj_loc )
     
     IMPLICIT NONE
@@ -667,8 +695,12 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: group_ref
       LOGICAL(KIND=C_BOOL) :: group_ref_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: i_index
+      LOGICAL(KIND=C_BOOL) :: i_index_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: ibegin
       LOGICAL(KIND=C_BOOL) :: ibegin_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: iend
       LOGICAL(KIND=C_BOOL) :: iend_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: j_index
+      LOGICAL(KIND=C_BOOL) :: j_index_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: jbegin
       LOGICAL(KIND=C_BOOL) :: jbegin_tmp
@@ -719,8 +751,8 @@
       CALL xios(is_defined_domaingroup_attr_hdl_)   &
       ( domaingroup_hdl, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin  &
-      , jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj  &
-      , zoom_nj_loc )
+      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, i_index, ibegin  &
+      , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
+      , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
+      , zoom_ni_loc, zoom_nj, zoom_nj_loc )
     
   END SUBROUTINE xios(is_defined_domaingroup_attr)
@@ -728,8 +760,8 @@
   SUBROUTINE xios(is_defined_domaingroup_attr_hdl)  &
     ( domaingroup_hdl, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin  &
-    , jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj  &
-    , zoom_nj_loc )
+    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, i_index, ibegin  &
+    , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
+    , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
+    , zoom_ni_loc, zoom_nj, zoom_nj_loc )
     
     IMPLICIT NONE
@@ -759,8 +791,12 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: group_ref
       LOGICAL(KIND=C_BOOL) :: group_ref_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: i_index
+      LOGICAL(KIND=C_BOOL) :: i_index_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: ibegin
       LOGICAL(KIND=C_BOOL) :: ibegin_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: iend
       LOGICAL(KIND=C_BOOL) :: iend_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: j_index
+      LOGICAL(KIND=C_BOOL) :: j_index_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: jbegin
       LOGICAL(KIND=C_BOOL) :: jbegin_tmp
@@ -810,8 +846,8 @@
       CALL xios(is_defined_domaingroup_attr_hdl_)  &
       ( domaingroup_hdl, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin  &
-      , jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj  &
-      , zoom_nj_loc )
+      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, group_ref, i_index, ibegin  &
+      , iend, j_index, jbegin, jend, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo  &
+      , nvertex, standard_name, type, zoom_ibegin, zoom_ibegin_loc, zoom_jbegin, zoom_jbegin_loc, zoom_ni  &
+      , zoom_ni_loc, zoom_nj, zoom_nj_loc )
     
   END SUBROUTINE xios(is_defined_domaingroup_attr_hdl)
@@ -819,8 +855,8 @@
   SUBROUTINE xios(is_defined_domaingroup_attr_hdl_)   &
     ( domaingroup_hdl, bounds_lat_, bounds_lon_, data_dim_, data_i_index_, data_ibegin_, data_j_index_  &
-    , data_jbegin_, data_n_index_, data_ni_, data_nj_, domain_group_ref_, group_ref_, ibegin_, iend_  &
-    , jbegin_, jend_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_, ni_glo_, nj_, nj_glo_  &
-    , nvertex_, standard_name_, type_, zoom_ibegin_, zoom_ibegin_loc_, zoom_jbegin_, zoom_jbegin_loc_  &
-    , zoom_ni_, zoom_ni_loc_, zoom_nj_, zoom_nj_loc_ )
+    , data_jbegin_, data_n_index_, data_ni_, data_nj_, domain_group_ref_, group_ref_, i_index_, ibegin_  &
+    , iend_, j_index_, jbegin_, jend_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_, ni_glo_  &
+    , nj_, nj_glo_, nvertex_, standard_name_, type_, zoom_ibegin_, zoom_ibegin_loc_, zoom_jbegin_  &
+    , zoom_jbegin_loc_, zoom_ni_, zoom_ni_loc_, zoom_nj_, zoom_nj_loc_ )
     
     IMPLICIT NONE
@@ -850,8 +886,12 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: group_ref_
       LOGICAL(KIND=C_BOOL) :: group_ref__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: i_index_
+      LOGICAL(KIND=C_BOOL) :: i_index__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: ibegin_
       LOGICAL(KIND=C_BOOL) :: ibegin__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: iend_
       LOGICAL(KIND=C_BOOL) :: iend__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: j_index_
+      LOGICAL(KIND=C_BOOL) :: j_index__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: jbegin_
       LOGICAL(KIND=C_BOOL) :: jbegin__tmp
@@ -959,4 +999,9 @@
       ENDIF
       
+      IF (PRESENT(i_index_)) THEN
+        i_index__tmp=cxios_is_defined_domaingroup_i_index(domaingroup_hdl%daddr)
+        i_index_=i_index__tmp
+      ENDIF
+      
       IF (PRESENT(ibegin_)) THEN
         ibegin__tmp=cxios_is_defined_domaingroup_ibegin(domaingroup_hdl%daddr)
@@ -969,4 +1014,9 @@
       ENDIF
       
+      IF (PRESENT(j_index_)) THEN
+        j_index__tmp=cxios_is_defined_domaingroup_j_index(domaingroup_hdl%daddr)
+        j_index_=j_index__tmp
+      ENDIF
+      
       IF (PRESENT(jbegin_)) THEN
         jbegin__tmp=cxios_is_defined_domaingroup_jbegin(domaingroup_hdl%daddr)